( 3iPiano.fs for 4x4 ports - AE - 2020-11-22---Sun---13:57 )

\ RECEIVE BUTTON PRESSES
: in4   11 10 9 8 ;  \ pins for input port, lsb on top of stack (8) 
\ SIGNAL LEDs
: out4  5 4 3 2 ;    \ pins for output port, lsb top of stack (2)
out4 use-port-out

create piano-key-map  
    $c c, $b c, $a c, $9 c, $8 c, $7 c, $6 c, $5 c, 
    $4 c, $3 c, $2 c, $1 c, $0 c, $f c, $e c, $d c, 

: piano-test  \ tests each light, prompted by key presses
    piano-key-map 16 0 do c@+ dup . _light_ key drop loop drop light| ;
: piano-flash
    piano-key-map 15 0 do c@+ _light_ loop drop light| 50 ms ;
: piano-flash-n
    0 do piano-flash loop ;

: init-piano
    out4 use-port-out 500 ms
    port4-in 500 ms
    start-speaker
    ." OK" cr ;


\ ========================================
: help-piano
  cr
  cr ." HELP-PIANO"
  cr ." ----------"
  cr 
  cr ." include 3iForth.fs 3iPort-4x4.fs 3iSound-4x4.fs 3iPiano.fs"
  cr 
  cr ." init-piano"
  cr ." press buttons for sound"
  cr ." press C for toggle between equitemper (c std), bhairav (indian) and yu (chinese scales)"
  cr
;

\ VERSION 1 - AE - 2020-11-22---Sun---14:37 - finished wiring the new boards, including fixes with underneath
